Qwt User's Guide 5.2.2

- Main Page
- Related Pages
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions

# QwtPlotGrid Class Reference

A class which draws a coordinate grid. More...

`#include <qwt_plot_grid.h>`

Inheritance diagram for QwtPlotGrid:
[legend]

List of all members.

## Public Types
enum | ItemAttribute { Legend = 1, AutoScale = 2 }
enum | RenderHint { RenderAntialiased = 1 }
enum | RttiValues { Rtti_PlotItem = 0, Rtti_PlotGrid, Rtti_PlotScale, Rtti_PlotMarker, Rtti_PlotCurve, Rtti_PlotHistogram, Rtti_PlotSpectrogram, Rtti_PlotSVG, Rtti_PlotUserItem = 1000 }
## Public Member Functions
void | attach (QwtPlot *plot)
virtual QwtDoubleRect | boundingRect () const
void | detach ()
virtual void | draw (QPainter *p, const QwtScaleMap &xMap, const QwtScaleMap &yMap, const QRect &rect) const
void | enableX (bool tf)
void | enableXMin (bool tf)
void | enableY (bool tf)
void | enableYMin (bool tf)
void | hide ()
QwtDoubleRect | invTransform (const QwtScaleMap &, const QwtScaleMap &, const QRect &) const
bool | isVisible () const
virtual void | itemChanged ()
virtual QWidget * | legendItem () const
const QPen & | majPen () const
const QPen & | minPen () const
QRect | paintRect (const QwtScaleMap &, const QwtScaleMap &) const
QwtPlot * | plot () const
| QwtPlotGrid ()
virtual int | rtti () const
QwtDoubleRect | scaleRect (const QwtScaleMap &, const QwtScaleMap &) const
void | setAxis (int xAxis, int yAxis)
void | setItemAttribute (ItemAttribute, bool on=true)
void | setMajPen (const QPen &p)
void | setMinPen (const QPen &p)
void | setPen (const QPen &p)
void | setRenderHint (RenderHint, bool on=true)
void | setTitle (const QString &title)
void | setTitle (const QwtText &title)
virtual void | setVisible (bool)
void | setXAxis (int axis)
void | setXDiv (const QwtScaleDiv &sx)
void | setYAxis (int axis)
void | setYDiv (const QwtScaleDiv &sy)
void | setZ (double z)
void | show ()
bool | testItemAttribute (ItemAttribute) const
bool | testRenderHint (RenderHint) const
const QwtText & | title () const
QRect | transform (const QwtScaleMap &, const QwtScaleMap &, const QwtDoubleRect &) const
virtual void | updateLegend (QwtLegend *) const
virtual void | updateScaleDiv (const QwtScaleDiv &xMap, const QwtScaleDiv &yMap)
int | xAxis () const
bool | xEnabled () const
bool | xMinEnabled () const
const QwtScaleDiv & | xScaleDiv () const
int | yAxis () const
bool | yEnabled () const
bool | yMinEnabled () const
const QwtScaleDiv & | yScaleDiv () const
double | z () const
virtual | ~QwtPlotGrid ()

## Detailed Description

A class which draws a coordinate grid.

The QwtPlotGrid class can be used to draw a coordinate grid. A coordinate grid consists of major and minor vertical and horizontal gridlines. The locations of the gridlines are determined by the X and Y scale divisions which can be assigned with setXDiv() and setYDiv(). The draw() member draws the grid within a bounding rectangle.

## Member Enumeration Documentation

enum QwtPlotItem::ItemAttribute`[inherited]`

Plot Item Attributes

- Legend
  The item is represented on the legend.
- AutoScale
  The boundingRect() of the item is included in the autoscaling calculation.

See also:
  setItemAttribute(), testItemAttribute()

enum QwtPlotItem::RenderHint`[inherited]`

Render hints.

enum QwtPlotItem::RttiValues`[inherited]`

Runtime type information.

RttiValues is used to cast plot items, without having to enable runtime type information of the compiler.

## Constructor & Destructor Documentation

QwtPlotGrid::QwtPlotGrid | ( |  | ) | `[explicit]`

Enables major grid, disables minor grid.

QwtPlotGrid::~QwtPlotGrid | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

void QwtPlotItem::attach | ( | QwtPlot * | plot | ) | `[inherited]`

Attach the item to a plot.

This method will attach a QwtPlotItem to the QwtPlot argument. It will first detach the QwtPlotItem from any plot from a previous call to attach (if necessary). If a NULL argument is passed, it will detach from any QwtPlot it was attached to.

Parameters:

  plot | Plot widget

See also:
  QwtPlotItem::detach()

QwtDoubleRect QwtPlotItem::boundingRect | ( |  | ) | const`[virtual, inherited]`

Returns:
  An invalid bounding rect: QwtDoubleRect(1.0, 1.0, -2.0, -2.0)

Reimplemented in QwtPlotCurve, QwtPlotMarker, QwtPlotSpectrogram, and QwtPlotSvgItem.

void QwtPlotItem::detach | ( |  | ) | `[inline, inherited]`

This method detaches a QwtPlotItem from any QwtPlot it has been associated with.

detach() is equivalent to calling attach( NULL )

See also:
  attach( QwtPlot* plot )

void QwtPlotGrid::draw | ( | QPainter * | painter,
|  | const QwtScaleMap & | xMap,
|  | const QwtScaleMap & | yMap,
|  | const QRect & | canvasRect
| ) |  | const`[virtual]`

Draw the grid.

The grid is drawn into the bounding rectangle such that gridlines begin and end at the rectangle's borders. The X and Y maps are used to map the scale divisions into the drawing region screen.

Parameters:

  painter | Painter
  xMap | X axis map
  yMap | Y axis
  canvasRect | Contents rect of the plot canvas

Implements QwtPlotItem.

void QwtPlotGrid::enableX | ( | bool | tf | ) |

Enable or disable vertical gridlines.

Parameters:

  tf | Enable (true) or disable

See also:
  Minor gridlines can be enabled or disabled with enableXMin()

void QwtPlotGrid::enableXMin | ( | bool | tf | ) |

Enable or disable minor vertical gridlines.

Parameters:

  tf | Enable (true) or disable

See also:
  enableX()

void QwtPlotGrid::enableY | ( | bool | tf | ) |

Enable or disable horizontal gridlines.

Parameters:

  tf | Enable (true) or disable

See also:
  Minor gridlines can be enabled or disabled with enableYMin()

void QwtPlotGrid::enableYMin | ( | bool | tf | ) |

Enable or disable minor horizontal gridlines.

Parameters:

  tf | Enable (true) or disable

See also:
  enableY()

void QwtPlotItem::hide | ( |  | ) | `[inherited]`

Hide the item.

QwtDoubleRect QwtPlotItem::invTransform | ( | const QwtScaleMap & | xMap,
|  | const QwtScaleMap & | yMap,
|  | const QRect & | rect
| ) |  | const`[inherited]`

Transform a rectangle from paint to scale coordinates

Parameters:

  xMap | X map
  yMap | Y map
  rect | Rectangle in paint coordinates

Returns:
  Rectangle in scale coordinates

See also:
  transform()

bool QwtPlotItem::isVisible | ( |  | ) | const`[inherited]`

Returns:
  true if visible

See also:
  setVisible(), show(), hide()

void QwtPlotItem::itemChanged | ( |  | ) | `[virtual, inherited]`

Update the legend and call QwtPlot::autoRefresh for the parent plot.

See also:
  updateLegend()

QWidget * QwtPlotItem::legendItem | ( |  | ) | const`[virtual, inherited]`

Allocate the widget that represents the item on the legend.

The default implementation is made for QwtPlotCurve and returns a QwtLegendItem(), but an item could be represented by any type of widget, by overloading legendItem() and updateLegend().

Returns:
  QwtLegendItem()

See also:
  updateLegend() QwtLegend()

Implements QwtLegendItemManager.

const QPen & QwtPlotGrid::majPen | ( |  | ) | const

Returns:
  the pen for the major gridlines

See also:
  setMajPen(), setMinPen(), setPen()

const QPen & QwtPlotGrid::minPen | ( |  | ) | const

Returns:
  the pen for the minor gridlines

See also:
  setMinPen(), setMajPen(), setPen()

QRect QwtPlotItem::paintRect | ( | const QwtScaleMap & | xMap,
|  | const QwtScaleMap & | yMap
| ) |  | const`[inherited]`

Calculate the bounding paint rect of 2 maps.

Parameters:

  xMap | X map
  yMap | X map

Returns:
  Bounding rect of the scale maps

QwtPlot * QwtPlotItem::plot | ( |  | ) | const`[inherited]`

Return attached plot.

int QwtPlotGrid::rtti | ( |  | ) | const`[virtual]`

Returns:
  QwtPlotItem::Rtti_PlotGrid

Reimplemented from QwtPlotItem.

QwtDoubleRect QwtPlotItem::scaleRect | ( | const QwtScaleMap & | xMap,
|  | const QwtScaleMap & | yMap
| ) |  | const`[inherited]`

Calculate the bounding scale rect of 2 maps.

Parameters:

  xMap | X map
  yMap | X map

Returns:
  Bounding rect of the scale maps

void QwtPlotItem::setAxis | ( | int | xAxis,
|  | int | yAxis
| ) |  | `[inherited]`

Set X and Y axis

The item will painted according to the coordinates its Axes.

Parameters:

  xAxis | X Axis
  yAxis | Y Axis

See also:
  setXAxis(), setYAxis(), xAxis(), yAxis()

void QwtPlotItem::setItemAttribute | ( | ItemAttribute | attribute,
|  | bool | on = `true`
| ) |  | `[inherited]`

Toggle an item attribute

Parameters:

  attribute | Attribute type
  on | true/false

See also:
  testItemAttribute(), ItemAttribute

void QwtPlotGrid::setMajPen | ( | const QPen & | pen | ) |

Assign a pen for the major gridlines

The width of non cosmetic pens is scaled according to the resolution of the paint device.

Parameters:

  pen | Pen

See also:
  majPen(), setMinPen(), setPen(), QwtPainter::scaledPen()

void QwtPlotGrid::setMinPen | ( | const QPen & | pen | ) |

Assign a pen for the minor gridlines

The width of non cosmetic pens is scaled according to the resolution of the paint device.

Parameters:

  pen | Pen

See also:
  minPen(), setMajPen(), setPen(), QwtPainter::scaledPen()

void QwtPlotGrid::setPen | ( | const QPen & | pen | ) |

Assign a pen for both major and minor gridlines

The width of non cosmetic pens is scaled according to the resolution of the paint device.

Parameters:

  pen | Pen

See also:
  setMajPen(), setMinPen(), QwtPainter::scaledPen()

void QwtPlotItem::setRenderHint | ( | RenderHint | hint,
|  | bool | on = `true`
| ) |  | `[inherited]`

Toggle an render hint

Parameters:

  hint | Render hint
  on | true/false

See also:
  testRenderHint(), RenderHint

void QwtPlotItem::setTitle | ( | const QwtText & | title | ) | `[inherited]`

Set a new title

Parameters:

  title | Title

See also:
  title()

void QwtPlotItem::setTitle | ( | const QString & | title | ) | `[inherited]`

Set a new title

Parameters:

  title | Title

See also:
  title()

void QwtPlotItem::setVisible | ( | bool | on | ) | `[virtual, inherited]`

Show/Hide the item

Parameters:

  on | Show if true, otherwise hide

See also:
  isVisible(), show(), hide()

void QwtPlotItem::setXAxis | ( | int | axis | ) | `[inherited]`

Set the X axis

The item will painted according to the coordinates its Axes.

Parameters:

  axis | X Axis

See also:
  setAxis(), setYAxis(), xAxis()

void QwtPlotGrid::setXDiv | ( | const QwtScaleDiv & | scaleDiv | ) |

Assign an x axis scale division

Parameters:

  scaleDiv | Scale division

void QwtPlotItem::setYAxis | ( | int | axis | ) | `[inherited]`

Set the Y axis

The item will painted according to the coordinates its Axes.

Parameters:

  axis | Y Axis

See also:
  setAxis(), setXAxis(), yAxis()

void QwtPlotGrid::setYDiv | ( | const QwtScaleDiv & | scaleDiv | ) |

Assign a y axis division

Parameters:

  scaleDiv | Scale division

void QwtPlotItem::setZ | ( | double | z | ) | `[inherited]`

Set the z value.

Plot items are painted in increasing z-order.

Parameters:

  z | Z-value

See also:
  z(), QwtPlotDict::itemList()

void QwtPlotItem::show | ( |  | ) | `[inherited]`

Show the item.

bool QwtPlotItem::testItemAttribute | ( | ItemAttribute | attribute | ) | const`[inherited]`

Test an item attribute

Parameters:

  attribute | Attribute type

Returns:
  true/false

See also:
  setItemAttribute(), ItemAttribute

bool QwtPlotItem::testRenderHint | ( | RenderHint | hint | ) | const`[inherited]`

Test a render hint

Parameters:

  hint | Render hint

Returns:
  true/false

See also:
  setRenderHint(), RenderHint

const QwtText & QwtPlotItem::title | ( |  | ) | const`[inherited]`

Returns:
  Title of the item

See also:
  setTitle()

QRect QwtPlotItem::transform | ( | const QwtScaleMap & | xMap,
|  | const QwtScaleMap & | yMap,
|  | const QwtDoubleRect & | rect
| ) |  | const`[inherited]`

Transform a rectangle

Parameters:

  xMap | X map
  yMap | Y map
  rect | Rectangle in scale coordinates

Returns:
  Rectangle in paint coordinates

See also:
  invTransform()

void QwtPlotItem::updateLegend | ( | QwtLegend * | legend | ) | const`[virtual, inherited]`

Update the widget that represents the item on the legend.

updateLegend() is called from itemChanged() to adopt the widget representing the item on the legend to its new configuration.

The default implementation is made for QwtPlotCurve and updates a QwtLegendItem(), but an item could be represented by any type of widget, by overloading legendItem() and updateLegend().

Parameters:

  legend | Legend

See also:
  legendItem(), itemChanged(), QwtLegend()

Implements QwtLegendItemManager.

Reimplemented in QwtPlotCurve.

void QwtPlotGrid::updateScaleDiv | ( | const QwtScaleDiv & | xScaleDiv,
|  | const QwtScaleDiv & | yScaleDiv
| ) |  | `[virtual]`

Update the grid to changes of the axes scale division

Parameters:

  xScaleDiv | Scale division of the x-axis
  yScaleDiv | Scale division of the y-axis

See also:
  QwtPlot::updateAxes()

Reimplemented from QwtPlotItem.

int QwtPlotItem::xAxis | ( |  | ) | const`[inherited]`

Return xAxis.

bool QwtPlotGrid::xEnabled | ( |  | ) | const

Returns:
  true if vertical gridlines are enabled

See also:
  enableX()

bool QwtPlotGrid::xMinEnabled | ( |  | ) | const

Returns:
  true if minor vertical gridlines are enabled

See also:
  enableXMin()

const QwtScaleDiv & QwtPlotGrid::xScaleDiv | ( |  | ) | const

Returns:
  the scale division of the x axis

int QwtPlotItem::yAxis | ( |  | ) | const`[inherited]`

Return yAxis.

bool QwtPlotGrid::yEnabled | ( |  | ) | const

Returns:
  true if horizontal gridlines are enabled

See also:
  enableY()

bool QwtPlotGrid::yMinEnabled | ( |  | ) | const

Returns:
  true if minor horizontal gridlines are enabled

See also:
  enableYMin()

const QwtScaleDiv & QwtPlotGrid::yScaleDiv | ( |  | ) | const

Returns:
  the scale division of the y axis

double QwtPlotItem::z | ( |  | ) | const`[inherited]`

Plot items are painted in increasing z-order.

Returns:
  setZ(), QwtPlotDict::itemList()